﻿#-------------------------------------------------------------------------------
# Author:      Krwemil
# Created:     20.03.2013
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# This script will change the output PDB files generated by Omega in this manner:
# -all hydrogens are removed
# -all ATOM entries converted to HETATM
# -all CONECT entries are removed
#
# IMPORTANT NOTE: Use this program only once per file
#-------------------------------------------------------------------------------

##def find_right_row(atom_number, new_rows):
##    right_row = ""
##    for new_row in new_rows:
##        if atom_number == int(new_row[7:11]):
##            right_row = new_row
##            break
##    return right_row

def find_ter(new_rows):
    ter = ""
    for new_row in new_rows:
        if "TER" in new_row:
            ter = new_row
            break
    return ter

def clean_output(ligand_ID, ordering, FE_row, confs_dir):
    rows = []
    resid_ID = ligand_ID
    resid_PATH = confs_dir + resid_ID + "/" + resid_ID + ".pdb"
    with open(resid_PATH,"r",encoding="UTF-8") as file:
        for row in file:
            rows.append(row)

    new_rows = []
##    H_counter = 0
##    atom_counter = 0
##    atom_count = 0
    for row in rows:
##        atom_counter+=1
        if "ATOM" in row:
            new_row = "HETATM" + row[6:17] + resid_ID + "     1" + row[26:]
            if ("H" in new_row[12:16]):
##                H_counter+=1
                continue
            else:
                new_rows.append(new_row)
##        elif "TER" in row:
##            new_row = "TER" + "   " + row[6:9]+ str(atom_counter - H_counter) + row[11:17] + resid_ID +  "     1" + row[26:]
##            atom_count = atom_counter - H_counter - 1
##            H_counter = 0
##            atom_counter = 0
##            new_rows.append(new_row)
        elif ("HETATM" in row) and (resid_ID not in row):
            new_row = row[0:17] + resid_ID + "     1" + row[26:]
            if ("HETATM" in new_row) and ("H" in new_row[12:16]) and (int(new_row[7:11]) == 0):
##                H_counter+=1
                continue
            else:
                new_rows.append(new_row)
        elif ("HETATM" in row) and ("H" in row[12:16]) and (int(row[7:11]) == 0):
                continue
        elif ("CONECT" in row):
##            atom_counter -= 1
            continue
        else:
##            atom_counter -= 1
            new_rows.append(row)

    #-load HETATM entries
    compnd = "COMPND    " + ligand_ID + ("\n")
    ter = find_ter(new_rows)
    compounds_data = []
    hets = []
    start = False
    for new_row in new_rows:
        if "COMPND" in new_row:
            start = True
        elif "TER" in new_row:
            start = False
            #incorporate Fe from heme back with zero coordinates
            if FE_row != "":
                hets.append(FE_row[:32] + " 0.000   0.000   0.000" + FE_row[54:])
            compounds_data.append(hets)
            hets = []
        elif start:
            hets.append(new_row)

    #-return atoms back to the pocket order
    new_rows = []
    for compound_data in compounds_data:
        repaired_hetatm_order = []
        for atom_number in ordering:
            for het in compound_data:
                if int(het[7:11]) == atom_number:
                    repaired_hetatm_order.append(het)
        new_rows.append(compnd)
        new_rows.extend(repaired_hetatm_order)
        new_rows.append(ter)
        new_rows.append("END\n")

    with open(resid_PATH,"w",encoding="UTF-8") as file:
        for new_row in new_rows:
            file.write(new_row)
