﻿#-------------------------------------------------------------------------------
# Author:      Krwemil
# Created:     29.04.2013
# -vyhodnoceni vysledku porovnavani
#-------------------------------------------------------------------------------

import os
import decimal

def main():
    decimal.getcontext().prec = 4
    D = decimal.Decimal
    conformers_yes = [x for x in os.listdir("pocket_similarity_out") if ".pdblogc" not in x]
    conformers_no = [x for x in os.listdir("pocket_similarity_out_no_conformers") if ".pdblogc" not in x]
    try:
        conformers_yes.remove("count_meanAUC.py")
    except:
        pass

    try:
        conformers_yes.remove("meanAUC.txt")
    except:
        pass

    try:
        conformers_no.remove("count_meanAUC.py")
    except:
        pass
    try:
        conformers_no.remove("meanAUC.txt")
    except:
        pass

    yes_scores = {}
    no_scores = {}

    for i,j in enumerate(conformers_yes):
        conformers_yes[i] = j.strip(".pdblog")
    for i,j in enumerate(conformers_no):
        conformers_no[i] = j.strip(".pdblog")

    for i in conformers_yes:
        yes_scores[i] = {}
        with open("pocket_similarity_out/" + i + ".pdblog", "r", encoding = "utf-8") as file:
            for row in file:
                row = row.strip()
                if row[0].isnumeric():
                    key = row[row.find(" ")+1:row.find(".pdb")]
##                    yes_scores[i][key] = []
                    yes_scores[i][key] = D(float(row[row.find(":")+2:row.rfind(",")]))

    for i in conformers_no:
        no_scores[i] = {}
        with open("pocket_similarity_out_no_conformers/" + i + ".pdblog", "r", encoding = "utf-8") as file:
            for row in file:
                row = row.strip()
                if row[0].isnumeric():
                    key = row[row.find(" ")+1:row.find(".pdb")]
##                    no_scores[i][key] = []
                    no_scores[i][key] = D(float(row[row.find(":")+2:row.rfind(",")]))

    diffs = {}
##    proc_diffs = {}
    for entry in yes_scores:
        diffs[entry] = {}
##        proc_diffs[entry] = {}
        for entry2 in yes_scores[entry]:
            difference = no_scores[entry][entry2] - yes_scores[entry][entry2]
            diffs[entry][entry2] = (difference, D(100) * (abs(difference) / no_scores[entry][entry2]))
##            proc_diffs[entry][entry2] = D(100) * (abs(diffs[entry][entry2]) / no_scores[entry][entry2]) #kolik % z puvodniho skoore tvori zmena

    with open("score_differences.txt", "w", encoding="utf-8") as out:
        out.write("# Zapis rozdilu ve skoore (bez pouziti konformaci - s pouzitim konformaci)\n")
        out.write("# Kladne cislo tedy znamena zlepseni ve skoore pri pouziti konformaci\n")
        out.write("# Procenta v zavorce oznacuji zmenu relativne vuci hodnote ziskane bez konformaci\n")
        querries = sorted(diffs)
        for polozka in querries:
            out.write(polozka + ": \n")
            base_diffs = list(diffs[polozka].items())
            base_diffs = sorted(base_diffs, key = lambda x: x[1][0])
            for polozka2 in base_diffs:
                out.write(" > " + polozka2[0] + " : " + str(polozka2[1][0]) + " (" + str(polozka2[1][1]) + "%)" + "\n")
##                out.write(" > " + polozka2 + " : " + str(diffs[polozka][polozka2]) + "\n")

    decimal.getcontext().prec = 5
    AUCs_yes = {}
    AUCs_no = {}
    AUC_files = ("pocket_similarity_out/meanAUC.txt","pocket_similarity_out_no_conformers/meanAUC.txt")

    with open(AUC_files[0], "r", encoding = "utf-8") as file:
        for row in file:
            if "meanAUC: " in row:
                AUCs_yes["meanAUC"] = D(float(row[9:].strip()))
            else:
                AUCs_yes[row[0:row.find(":")-1]] = D(float(row[row.find(":")+1:].strip()))

    with open(AUC_files[1], "r", encoding = "utf-8") as file:
        for row in file:
            if "meanAUC: " in row:
                AUCs_no["meanAUC"] = D(float(row[9:].strip()))
            else:
                AUCs_no[row[0:row.find(":")-1]] = D(float(row[row.find(":")+1:].strip()))

    AUC_diffs = {}
    for i in AUCs_yes:
            AUC_diffs[i] =  AUCs_yes[i] - AUCs_no[i]

    AUC_diffs_list = []
    for i in AUC_diffs:
        AUC_diffs_list.append( (i, AUC_diffs[i]) )
    AUC_diffs_list.sort(key = lambda x: x[1])
    AUC_diffs_list.reverse()

    with open("AUC_differences.txt", "w", encoding = "utf-8") as outfile:
        outfile.write("# Zapis rozdilu AUC (s pouzitim konformaci - bez pouziti konformaci)\n")
        outfile.write("# Kladne cislo tedy znamena zlepseni v AUC pri pouziti konformaci\n")
        for i in AUC_diffs_list:
            outfile.write(i[0] + " : " + str(i[1]) + "\n")





if __name__ == '__main__':
    main()
