﻿#-------------------------------------------------------------------------------
# Author:      Krwemil
# Created:     08.05.2013
#-------------------------------------------------------------------------------
import os
import decimal

def main():
    decimal.getcontext().prec = 6
    D = decimal.Decimal
    conformers_yes = [x for x in os.listdir("pocket_similarity_out") if (".pdblogc" in x) and (".pdblogcx" not in x)]
    skipped = 26 #pocet preskocenych pocketu

##    ligand_codes = {x[x.find("_")+1:x.find(".pdb")] for x in conformers_yes} # uncomment for homogenous
    ligand_codes = {x[x.find("_")+1:x.rfind("_")] for x in conformers_yes} # uncomment for kahraman
    ligand_codes_dict = dict()
    for i in ligand_codes:
        ligand_codes_dict[i] = []

    best_three_dict = dict()
    best_one_dict = dict()

    ligand_codes_dict_good_confs_search = dict()
    for i in ligand_codes:
        ligand_codes_dict_good_confs_search[i] = set()

    result_set = []
    for entry in conformers_yes:
        best_three_dict[entry] = []
        best_one_dict[entry] = []
##        current_ligand = entry[entry.find("_")+1:entry.find(".pdb")]
        current_ligand = entry[entry.find("_")+1:entry.rfind("_")]
        scores = []
        with open("pocket_similarity_out/" + entry, "r", encoding = "utf-8") as file_yes:
            current_file = str()
##            current_ligand = str()
            counter = -1
            for line in file_yes:
                if line[0].isnumeric():
                    current_file = line[line.find(" ")+1:line.rfind("-")-1]
##                    current_ligand = line[line.find("_")+1:line.find(".pdb")]
                    scores.append((current_file, []))
                    counter+=1
                if line[1] == ">":
                    scores[counter][1].append(D(line[line.rfind(" ")+1:].strip()))

        results = []
        for  pocket in scores:
            above = 0
            above_scores = []
            below_scores = []
            above_perc = 0
            best_three_confs_avg = D(0)
            ligand_codes_dict_good_confs_search[current_ligand].add(len(pocket[1][1:]))
            for i,score in enumerate(pocket[1][1:]):
                if score > pocket[1][0]:
                    above_scores.append(score)
                    above+=1
                if score < pocket[1][0]:
                    ligand_codes_dict_good_confs_search[current_ligand].add(i)
                    below_scores.append(score)
            if above:
                above_perc = D((above / (len(pocket[1])-1)) * 100) #kolik procent z konformaci melo vetsi score

            avg_above = D(0)
            avg_below = D(0)
            if above_scores:
                avg_above = 100 * (sum(above_scores) / len(above_scores) - pocket[1][0]) / pocket[1][0]
                ligand_codes_dict[current_ligand].append(avg_above)

            if below_scores:
                avg_below = 100 * (sum(below_scores) / len(below_scores) - pocket[1][0]) / pocket[1][0]
                ligand_codes_dict[current_ligand].append(avg_below)

            if len(pocket[1]) > 1:
                score_seznam = pocket[1][1:]
                sumace = sum([x for x in sorted(score_seznam)[0:3]])
                delka = D(len(score_seznam[0:3]))
                puvodni = D(pocket[1][0])
                prumer = sumace / delka
                rozdil = prumer - puvodni
                podil = rozdil / puvodni
                best_three_confs_avg = D(100) * podil
                best_three_dict[entry].append(best_three_confs_avg)

                nejlepsi = sorted(score_seznam)[0]
                best_one_dict[entry].append(D(100 * (nejlepsi - puvodni) / puvodni))

            results.append((pocket[0], avg_above, avg_below, above_perc, best_three_confs_avg))

        results.sort(key = lambda x: x[4])
##        results.reverse()
        best_three_dict[entry] = D(sum(best_three_dict[entry]) / len(results))
        best_one_dict[entry] = D(sum(best_one_dict[entry]) / len(results))
        result_set.append((entry, results))
        print(entry)

    total_above_percentage = []
    for pocket in result_set:
        with open("pocket_similarity_out/" + pocket[0] + "x", "w", encoding = "utf-8") as outfile:
            counter_above = 0
            for entry in pocket[1]:
                if (entry[2] < D(0)) and (abs(entry[2]) > entry[1]):
                    counter_above+=1
                outfile.write(entry[0] + " : above average = " + str(entry[1]) + " % | below average = "  + str(entry[2]) + " % | improvement cases (%) = " + str(100 - entry[3]) + " % | best three improvement = " + str(entry[4]) + "%\n")
            above_perc = 100 * D((counter_above / len(pocket[1])))
            total_above_percentage.append(above_perc)
            outfile.write("total below score percentage: " + str(above_perc) + " %\n#total below score percentage = pripady, kde score prumerne vylepseno o hodnotu vetsi, nez bylo prumerne zhorseni \n")
            outfile.write("average best three conformer score improvement: " + str(best_three_dict[pocket[0]]) + " %")

    with open("total_below_percentage.txt", "w", encoding = "utf-8") as outfile:
        for i,pocket in enumerate(result_set):
            outfile.write(pocket[0] + ": " + str(total_above_percentage[i]) + " % | average best three conformer score improvement: " + str(best_three_dict[pocket[0]]) + " %\n")
        outfile.write("total below score percentage = " + str(sum(total_above_percentage) / (len(result_set) - skipped)) + " %\n")
        outfile.write("overall best three conformer score improvement = " + str(sum([x for x in best_three_dict.values() if x < 0]) / (len(best_three_dict) - skipped)) + " %\n")
        outfile.write("overall one best conformer score improvement = " + str(sum([x for x in best_one_dict.values() if x < 0]) / (len(best_one_dict) - skipped)) + " %\n")

        good_freq = 0
        for entry in best_three_dict:
##            print(best_three_dict[entry])
            if best_three_dict[entry] < D(0):
                good_freq += 1
##        print(len(best_three_dict) - skipped)
##        print(good_freq)
        outfile.write("overall best three conformer score improvement frequency = " + str(100 * good_freq / (len(best_three_dict) - skipped)) + " %\n")

        good_freq = 0
        for entry in best_one_dict:
##            print(best_three_dict[entry])
            if best_one_dict[entry] < D(0):
                good_freq += 1
        outfile.write("overall one best conformer score improvement frequency = " + str(100 * good_freq / (len(best_one_dict) - skipped)) + " %\n")

        outfile.write("#Preskocene pripady, kde byly chyby s poctem atomu, nejsou v total uvazovany\n#total below score percentage = pripady, kde score prumerne vylepseno o hodnotu vetsi, nez bylo prumerne zhorseni\n")
        outfile.write("#overall best three conformer score improvement = o kolik procent vuci skore puvodni konformace ligandu se pri zahrnuti pouze maximalne 3 nejlepsich konformaci (ktere mely skore vetsi nez puvodni konformace ligandu) skore prumerne vylepsilo\n")
        outfile.write("#overall best three conformer score improvement frequency = u kolika procent pocketů existovala alespoň jedna konformace, která měla skore lepší než původní konformace ligandu")

    with open("total_below_percentage_ligands.txt", "w", encoding = "utf-8") as outfile:
        outfile.write("#rozpis zlepseni pro jednotlive ligandy v datasetu celkem\n")
        total_below_percentage_ligands = []
        for entry in ligand_codes_dict:
            below_counter = 0
            below_counter2 = 0
            above_counter = 0
            below_sum = D(0)
            above_sum = D(0)
            for value in ligand_codes_dict[entry]:
                if value < 0:
                    below_sum += value
                    below_counter += 1
                    below_counter2 += 1
                else:
                    above_counter += 1
                    above_sum += value
            if not(above_counter):
                above_counter = 1
            if not(below_counter):
                below_counter = 1
                below_counter2 = 0
##            if len(ligand_codes_dict[entry]) == 0:
##                print(ligand_codes_dict)
##                print(entry)
            if ligand_codes_dict[entry] == []:
                ligand_codes_dict[entry].append(1)

            confs_count = max(ligand_codes_dict_good_confs_search[entry])
            ligand_codes_dict_good_confs_search[entry].discard(confs_count)
            confs_good_count = len(ligand_codes_dict_good_confs_search[entry])


            total_below_percentage_ligands.append((entry,100 * below_counter2 / len(ligand_codes_dict[entry]), above_sum/above_counter, below_sum/below_counter, confs_good_count, confs_count))
        total_below_percentage_ligands.sort(key = lambda x: x[1])
        for entry in total_below_percentage_ligands:
            outfile.write(entry[0] + ":\n > average score improvement = " + str(entry[3]) + " %\n > OK confs = " + str(entry[4]) + "/" + str(entry[5]) + "\n") #"%\n > average score addition = +" + str(entry[2])
##        outfile.write("#score improvement frequency = procentualni podil konformaci, ktere ziskaly skore vetsi nez puvodni experimentalni konformace, ze vsech konformaci\n")
        outfile.write("#average score improvement = o kolik procent konformace daneho ligandu v prumeru zlepsily skore")







if __name__ == '__main__':
    main()
