﻿#-------------------------------------------------------------------------------
# Author:      Krwemil
# Created:     26.03.2013
#-------------------------------------------------------------------------------

import os

def save_order(hets):
    ordering = []
    for atom in hets:
        ordering.append(int(atom[7:11]))
    return tuple(ordering)


def extract_ligands (dataset_folder_name, ligands_dir):
    pockets_path = dataset_folder_name + "/pockets/"
    pockets_files_path = [pockets_path + x for x in os.listdir(pockets_path)]

    if dataset_folder_name == "kahraman":
        ligand_codes = {x[x.rfind("_")-3:x.rfind("_")] for x in pockets_files_path}
    elif dataset_folder_name == "homogenous-dataset":
        ligand_codes = {x[x.rfind("_")+1:x.rfind("_")+4] for x in pockets_files_path}

    if not os.path.exists(ligands_dir):
        os.makedirs(ligands_dir)

    orderings = dict()
    for pocket_path in pockets_files_path:
        if dataset_folder_name == "kahraman":
            ligand_code = pocket_path[pocket_path.rfind("_")-3:pocket_path.rfind("_")]
        elif dataset_folder_name == "homogenous-dataset":
            ligand_code = pocket_path[pocket_path.rfind("_")+1:pocket_path.rfind("_")+4]

        if ligand_code in ligand_codes:
            hets = []
            with open(pocket_path, "r", encoding = "utf-8") as file:
                for radka in file:
                    if radka.startswith("HETATM"):
                        hets.append(radka)

            ordering = save_order(hets)
            orderings[ligand_code] = ordering

            with open(ligands_dir + ligand_code + ".pdb", "w", encoding = "utf-8") as output:
                for het in hets:
                    output.write(het)
            ligand_codes.discard(ligand_code)
    return orderings
